/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.eclipse.hyades.models.common.configuration.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.hyades.models.common.configuration.CFGArtifact;
import org.eclipse.hyades.models.common.configuration.CFGDeployable;
import org.eclipse.hyades.models.common.configuration.CFGInstance;
import org.eclipse.hyades.models.common.configuration.CFGOperation;
import org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage;

import org.eclipse.hyades.models.common.interactions.BVRLifeline;
import org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>CFG Deployable</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.CFGDeployableImpl#getId <em>Id</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.CFGDeployableImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.CFGDeployableImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.CFGDeployableImpl#getBehaviorResource <em>Behavior Resource</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.CFGDeployableImpl#getBehaviorLocation <em>Behavior Location</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.CFGDeployableImpl#getOperations <em>Operations</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.CFGDeployableImpl#getLifelines <em>Lifelines</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.CFGDeployableImpl#getArtifacts <em>Artifacts</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.CFGDeployableImpl#getInstances <em>Instances</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class CFGDeployableImpl extends EObjectImpl implements CFGDeployable
{
	/**
	 * The default value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected static final String ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected String id = ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getBehaviorResource() <em>Behavior Resource</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBehaviorResource()
	 * @generated
	 * @ordered
	 */
	protected static final String BEHAVIOR_RESOURCE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getBehaviorResource() <em>Behavior Resource</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBehaviorResource()
	 * @generated
	 * @ordered
	 */
	protected String behaviorResource = BEHAVIOR_RESOURCE_EDEFAULT;

	/**
	 * The default value of the '{@link #getBehaviorLocation() <em>Behavior Location</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBehaviorLocation()
	 * @generated
	 * @ordered
	 */
	protected static final String BEHAVIOR_LOCATION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getBehaviorLocation() <em>Behavior Location</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBehaviorLocation()
	 * @generated
	 * @ordered
	 */
	protected String behaviorLocation = BEHAVIOR_LOCATION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getOperations() <em>Operations</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOperations()
	 * @generated
	 * @ordered
	 */
	protected EList operations = null;

	/**
	 * The cached value of the '{@link #getLifelines() <em>Lifelines</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLifelines()
	 * @generated
	 * @ordered
	 */
	protected EList lifelines = null;

	/**
	 * The cached value of the '{@link #getArtifacts() <em>Artifacts</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getArtifacts()
	 * @generated
	 * @ordered
	 */
	protected EList artifacts = null;

	/**
	 * The cached value of the '{@link #getInstances() <em>Instances</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInstances()
	 * @generated
	 * @ordered
	 */
	protected EList instances = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CFGDeployableImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass()
	{
		return Common_ConfigurationPackage.eINSTANCE.getCFGDeployable();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getId()
	{
		return id;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setId(String newId)
	{
		String oldId = id;
		id = newId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_ConfigurationPackage.CFG_DEPLOYABLE__ID, oldId, id));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName()
	{
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName)
	{
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_ConfigurationPackage.CFG_DEPLOYABLE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription()
	{
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription)
	{
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_ConfigurationPackage.CFG_DEPLOYABLE__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getBehaviorResource()
	{
		return behaviorResource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBehaviorResource(String newBehaviorResource)
	{
		String oldBehaviorResource = behaviorResource;
		behaviorResource = newBehaviorResource;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_ConfigurationPackage.CFG_DEPLOYABLE__BEHAVIOR_RESOURCE, oldBehaviorResource, behaviorResource));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getBehaviorLocation()
	{
		return behaviorLocation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBehaviorLocation(String newBehaviorLocation)
	{
		String oldBehaviorLocation = behaviorLocation;
		behaviorLocation = newBehaviorLocation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_ConfigurationPackage.CFG_DEPLOYABLE__BEHAVIOR_LOCATION, oldBehaviorLocation, behaviorLocation));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getOperations()
	{
		if (operations == null)
		{
			operations = new EObjectContainmentWithInverseEList(CFGOperation.class, this, Common_ConfigurationPackage.CFG_DEPLOYABLE__OPERATIONS, Common_ConfigurationPackage.CFG_OPERATION__DEPLOYABLE);
		}
		return operations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getLifelines()
	{
		if (lifelines == null)
		{
			lifelines = new EObjectWithInverseResolvingEList(BVRLifeline.class, this, Common_ConfigurationPackage.CFG_DEPLOYABLE__LIFELINES, Common_Behavior_InteractionsPackage.BVR_LIFELINE__DEPLOYABLE);
		}
		return lifelines;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getArtifacts()
	{
		if (artifacts == null)
		{
			artifacts = new EObjectWithInverseResolvingEList.ManyInverse(CFGArtifact.class, this, Common_ConfigurationPackage.CFG_DEPLOYABLE__ARTIFACTS, Common_ConfigurationPackage.CFG_ARTIFACT__DEPLOYABLE_INSTANCES);
		}
		return artifacts;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getInstances()
	{
		if (instances == null)
		{
			instances = new EObjectContainmentWithInverseEList(CFGInstance.class, this, Common_ConfigurationPackage.CFG_DEPLOYABLE__INSTANCES, Common_ConfigurationPackage.CFG_INSTANCE__DEPLOYABLE_OWNER);
		}
		return instances;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs)
	{
		if (featureID >= 0)
		{
			switch (eDerivedStructuralFeatureID(featureID, baseClass))
			{
				case Common_ConfigurationPackage.CFG_DEPLOYABLE__OPERATIONS:
					return ((InternalEList)getOperations()).basicAdd(otherEnd, msgs);
				case Common_ConfigurationPackage.CFG_DEPLOYABLE__LIFELINES:
					return ((InternalEList)getLifelines()).basicAdd(otherEnd, msgs);
				case Common_ConfigurationPackage.CFG_DEPLOYABLE__ARTIFACTS:
					return ((InternalEList)getArtifacts()).basicAdd(otherEnd, msgs);
				case Common_ConfigurationPackage.CFG_DEPLOYABLE__INSTANCES:
					return ((InternalEList)getInstances()).basicAdd(otherEnd, msgs);
				default:
					return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs)
	{
		if (featureID >= 0)
		{
			switch (eDerivedStructuralFeatureID(featureID, baseClass))
			{
				case Common_ConfigurationPackage.CFG_DEPLOYABLE__OPERATIONS:
					return ((InternalEList)getOperations()).basicRemove(otherEnd, msgs);
				case Common_ConfigurationPackage.CFG_DEPLOYABLE__LIFELINES:
					return ((InternalEList)getLifelines()).basicRemove(otherEnd, msgs);
				case Common_ConfigurationPackage.CFG_DEPLOYABLE__ARTIFACTS:
					return ((InternalEList)getArtifacts()).basicRemove(otherEnd, msgs);
				case Common_ConfigurationPackage.CFG_DEPLOYABLE__INSTANCES:
					return ((InternalEList)getInstances()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__ID:
				return getId();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__NAME:
				return getName();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__DESCRIPTION:
				return getDescription();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__BEHAVIOR_RESOURCE:
				return getBehaviorResource();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__BEHAVIOR_LOCATION:
				return getBehaviorLocation();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__OPERATIONS:
				return getOperations();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__LIFELINES:
				return getLifelines();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__ARTIFACTS:
				return getArtifacts();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__INSTANCES:
				return getInstances();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__ID:
				setId((String)newValue);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__NAME:
				setName((String)newValue);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__BEHAVIOR_RESOURCE:
				setBehaviorResource((String)newValue);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__BEHAVIOR_LOCATION:
				setBehaviorLocation((String)newValue);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__OPERATIONS:
				getOperations().clear();
				getOperations().addAll((Collection)newValue);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__LIFELINES:
				getLifelines().clear();
				getLifelines().addAll((Collection)newValue);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__ARTIFACTS:
				getArtifacts().clear();
				getArtifacts().addAll((Collection)newValue);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__INSTANCES:
				getInstances().clear();
				getInstances().addAll((Collection)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__ID:
				setId(ID_EDEFAULT);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__BEHAVIOR_RESOURCE:
				setBehaviorResource(BEHAVIOR_RESOURCE_EDEFAULT);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__BEHAVIOR_LOCATION:
				setBehaviorLocation(BEHAVIOR_LOCATION_EDEFAULT);
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__OPERATIONS:
				getOperations().clear();
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__LIFELINES:
				getLifelines().clear();
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__ARTIFACTS:
				getArtifacts().clear();
				return;
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__INSTANCES:
				getInstances().clear();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__BEHAVIOR_RESOURCE:
				return BEHAVIOR_RESOURCE_EDEFAULT == null ? behaviorResource != null : !BEHAVIOR_RESOURCE_EDEFAULT.equals(behaviorResource);
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__BEHAVIOR_LOCATION:
				return BEHAVIOR_LOCATION_EDEFAULT == null ? behaviorLocation != null : !BEHAVIOR_LOCATION_EDEFAULT.equals(behaviorLocation);
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__OPERATIONS:
				return operations != null && !operations.isEmpty();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__LIFELINES:
				return lifelines != null && !lifelines.isEmpty();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__ARTIFACTS:
				return artifacts != null && !artifacts.isEmpty();
			case Common_ConfigurationPackage.CFG_DEPLOYABLE__INSTANCES:
				return instances != null && !instances.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString()
	{
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (id: ");
		result.append(id);
		result.append(", name: ");
		result.append(name);
		result.append(", description: ");
		result.append(description);
		result.append(", behaviorResource: ");
		result.append(behaviorResource);
		result.append(", behaviorLocation: ");
		result.append(behaviorLocation);
		result.append(')');
		return result.toString();
	}

} //CFGDeployableImpl
