/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.eclipse.hyades.models.common.interactions.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.hyades.models.common.configuration.CFGDeployable;
import org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage;

import org.eclipse.hyades.models.common.fragments.BVRInteraction;
import org.eclipse.hyades.models.common.fragments.BVRPartDecomposition;
import org.eclipse.hyades.models.common.fragments.Common_Behavior_FragmentsPackage;

import org.eclipse.hyades.models.common.interactions.BVRInteractionFragment;
import org.eclipse.hyades.models.common.interactions.BVRLifeline;
import org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>BVR Lifeline</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVRLifelineImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVRLifelineImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVRLifelineImpl#getCount <em>Count</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVRLifelineImpl#getInterationFragments <em>Interation Fragments</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVRLifelineImpl#getPartDecomposition <em>Part Decomposition</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVRLifelineImpl#getInteraction <em>Interaction</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVRLifelineImpl#getDeployable <em>Deployable</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class BVRLifelineImpl extends EObjectImpl implements BVRLifeline
{
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The default value of the '{@link #getCount() <em>Count</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCount()
	 * @generated
	 * @ordered
	 */
	protected static final int COUNT_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getCount() <em>Count</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCount()
	 * @generated
	 * @ordered
	 */
	protected int count = COUNT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getInterationFragments() <em>Interation Fragments</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterationFragments()
	 * @generated
	 * @ordered
	 */
	protected EList interationFragments = null;

	/**
	 * The cached value of the '{@link #getPartDecomposition() <em>Part Decomposition</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPartDecomposition()
	 * @generated
	 * @ordered
	 */
	protected BVRPartDecomposition partDecomposition = null;

	/**
	 * The cached value of the '{@link #getDeployable() <em>Deployable</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDeployable()
	 * @generated
	 * @ordered
	 */
	protected CFGDeployable deployable = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BVRLifelineImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass()
	{
		return Common_Behavior_InteractionsPackage.eINSTANCE.getBVRLifeline();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName()
	{
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName)
	{
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_LIFELINE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription()
	{
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription)
	{
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_LIFELINE__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getCount()
	{
		return count;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCount(int newCount)
	{
		int oldCount = count;
		count = newCount;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_LIFELINE__COUNT, oldCount, count));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getInterationFragments()
	{
		if (interationFragments == null)
		{
			interationFragments = new EObjectWithInverseResolvingEList.ManyInverse(BVRInteractionFragment.class, this, Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERATION_FRAGMENTS, Common_Behavior_InteractionsPackage.BVR_INTERACTION_FRAGMENT__LIFELINES);
		}
		return interationFragments;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRPartDecomposition getPartDecomposition()
	{
		if (partDecomposition != null && partDecomposition.eIsProxy())
		{
			BVRPartDecomposition oldPartDecomposition = partDecomposition;
			partDecomposition = (BVRPartDecomposition)EcoreUtil.resolve(partDecomposition, this);
			if (partDecomposition != oldPartDecomposition)
			{
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_Behavior_InteractionsPackage.BVR_LIFELINE__PART_DECOMPOSITION, oldPartDecomposition, partDecomposition));
			}
		}
		return partDecomposition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRPartDecomposition basicGetPartDecomposition()
	{
		return partDecomposition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPartDecomposition(BVRPartDecomposition newPartDecomposition)
	{
		BVRPartDecomposition oldPartDecomposition = partDecomposition;
		partDecomposition = newPartDecomposition;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_LIFELINE__PART_DECOMPOSITION, oldPartDecomposition, partDecomposition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRInteraction getInteraction()
	{
		if (eContainerFeatureID != Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERACTION) return null;
		return (BVRInteraction)eContainer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInteraction(BVRInteraction newInteraction)
	{
		if (newInteraction != eContainer || (eContainerFeatureID != Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERACTION && newInteraction != null))
		{
			if (EcoreUtil.isAncestor(this, newInteraction))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newInteraction != null)
				msgs = ((InternalEObject)newInteraction).eInverseAdd(this, Common_Behavior_FragmentsPackage.BVR_INTERACTION__LIFELINES, BVRInteraction.class, msgs);
			msgs = eBasicSetContainer((InternalEObject)newInteraction, Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERACTION, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERACTION, newInteraction, newInteraction));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGDeployable getDeployable()
	{
		if (deployable != null && deployable.eIsProxy())
		{
			CFGDeployable oldDeployable = deployable;
			deployable = (CFGDeployable)EcoreUtil.resolve(deployable, this);
			if (deployable != oldDeployable)
			{
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_Behavior_InteractionsPackage.BVR_LIFELINE__DEPLOYABLE, oldDeployable, deployable));
			}
		}
		return deployable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGDeployable basicGetDeployable()
	{
		return deployable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDeployable(CFGDeployable newDeployable, NotificationChain msgs)
	{
		CFGDeployable oldDeployable = deployable;
		deployable = newDeployable;
		if (eNotificationRequired())
		{
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_LIFELINE__DEPLOYABLE, oldDeployable, newDeployable);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDeployable(CFGDeployable newDeployable)
	{
		if (newDeployable != deployable)
		{
			NotificationChain msgs = null;
			if (deployable != null)
				msgs = ((InternalEObject)deployable).eInverseRemove(this, Common_ConfigurationPackage.CFG_DEPLOYABLE__LIFELINES, CFGDeployable.class, msgs);
			if (newDeployable != null)
				msgs = ((InternalEObject)newDeployable).eInverseAdd(this, Common_ConfigurationPackage.CFG_DEPLOYABLE__LIFELINES, CFGDeployable.class, msgs);
			msgs = basicSetDeployable(newDeployable, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_LIFELINE__DEPLOYABLE, newDeployable, newDeployable));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs)
	{
		if (featureID >= 0)
		{
			switch (eDerivedStructuralFeatureID(featureID, baseClass))
			{
				case Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERATION_FRAGMENTS:
					return ((InternalEList)getInterationFragments()).basicAdd(otherEnd, msgs);
				case Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERACTION:
					if (eContainer != null)
						msgs = eBasicRemoveFromContainer(msgs);
					return eBasicSetContainer(otherEnd, Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERACTION, msgs);
				case Common_Behavior_InteractionsPackage.BVR_LIFELINE__DEPLOYABLE:
					if (deployable != null)
						msgs = ((InternalEObject)deployable).eInverseRemove(this, Common_ConfigurationPackage.CFG_DEPLOYABLE__LIFELINES, CFGDeployable.class, msgs);
					return basicSetDeployable((CFGDeployable)otherEnd, msgs);
				default:
					return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs)
	{
		if (featureID >= 0)
		{
			switch (eDerivedStructuralFeatureID(featureID, baseClass))
			{
				case Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERATION_FRAGMENTS:
					return ((InternalEList)getInterationFragments()).basicRemove(otherEnd, msgs);
				case Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERACTION:
					return eBasicSetContainer(null, Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERACTION, msgs);
				case Common_Behavior_InteractionsPackage.BVR_LIFELINE__DEPLOYABLE:
					return basicSetDeployable(null, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs)
	{
		if (eContainerFeatureID >= 0)
		{
			switch (eContainerFeatureID)
			{
				case Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERACTION:
					return ((InternalEObject)eContainer).eInverseRemove(this, Common_Behavior_FragmentsPackage.BVR_INTERACTION__LIFELINES, BVRInteraction.class, msgs);
				default:
					return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return ((InternalEObject)eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__NAME:
				return getName();
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__DESCRIPTION:
				return getDescription();
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__COUNT:
				return new Integer(getCount());
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERATION_FRAGMENTS:
				return getInterationFragments();
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__PART_DECOMPOSITION:
				if (resolve) return getPartDecomposition();
				return basicGetPartDecomposition();
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERACTION:
				return getInteraction();
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__DEPLOYABLE:
				if (resolve) return getDeployable();
				return basicGetDeployable();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__NAME:
				setName((String)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__COUNT:
				setCount(((Integer)newValue).intValue());
				return;
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERATION_FRAGMENTS:
				getInterationFragments().clear();
				getInterationFragments().addAll((Collection)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__PART_DECOMPOSITION:
				setPartDecomposition((BVRPartDecomposition)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERACTION:
				setInteraction((BVRInteraction)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__DEPLOYABLE:
				setDeployable((CFGDeployable)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__COUNT:
				setCount(COUNT_EDEFAULT);
				return;
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERATION_FRAGMENTS:
				getInterationFragments().clear();
				return;
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__PART_DECOMPOSITION:
				setPartDecomposition((BVRPartDecomposition)null);
				return;
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERACTION:
				setInteraction((BVRInteraction)null);
				return;
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__DEPLOYABLE:
				setDeployable((CFGDeployable)null);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__COUNT:
				return count != COUNT_EDEFAULT;
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERATION_FRAGMENTS:
				return interationFragments != null && !interationFragments.isEmpty();
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__PART_DECOMPOSITION:
				return partDecomposition != null;
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__INTERACTION:
				return getInteraction() != null;
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE__DEPLOYABLE:
				return deployable != null;
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString()
	{
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", description: ");
		result.append(description);
		result.append(", count: ");
		result.append(count);
		result.append(')');
		return result.toString();
	}

} //BVRLifelineImpl
