/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.eclipse.hyades.models.common.testprofile.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage;

import org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl;

import org.eclipse.hyades.models.common.fragments.Common_Behavior_FragmentsPackage;

import org.eclipse.hyades.models.common.fragments.impl.Common_Behavior_FragmentsPackageImpl;

import org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage;

import org.eclipse.hyades.models.common.interactions.impl.Common_Behavior_InteractionsPackageImpl;

import org.eclipse.hyades.models.common.testprofile.Common_TestprofileFactory;
import org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage;
import org.eclipse.hyades.models.common.testprofile.TPFArbiter;
import org.eclipse.hyades.models.common.testprofile.TPFBehavior;
import org.eclipse.hyades.models.common.testprofile.TPFCodingRule;
import org.eclipse.hyades.models.common.testprofile.TPFDefault;
import org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication;
import org.eclipse.hyades.models.common.testprofile.TPFDeployment;
import org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent;
import org.eclipse.hyades.models.common.testprofile.TPFExecutionHistory;
import org.eclipse.hyades.models.common.testprofile.TPFExecutionResult;
import org.eclipse.hyades.models.common.testprofile.TPFExecutionStatus;
import org.eclipse.hyades.models.common.testprofile.TPFExecutionType;
import org.eclipse.hyades.models.common.testprofile.TPFInstanceValue;
import org.eclipse.hyades.models.common.testprofile.TPFInvocationEvent;
import org.eclipse.hyades.models.common.testprofile.TPFInvocationReason;
import org.eclipse.hyades.models.common.testprofile.TPFInvocationStatus;
import org.eclipse.hyades.models.common.testprofile.TPFLiteralAny;
import org.eclipse.hyades.models.common.testprofile.TPFLiteralAnyorNull;
import org.eclipse.hyades.models.common.testprofile.TPFLogAction;
import org.eclipse.hyades.models.common.testprofile.TPFMessageEvent;
import org.eclipse.hyades.models.common.testprofile.TPFSUT;
import org.eclipse.hyades.models.common.testprofile.TPFSeverity;
import org.eclipse.hyades.models.common.testprofile.TPFTest;
import org.eclipse.hyades.models.common.testprofile.TPFTestCase;
import org.eclipse.hyades.models.common.testprofile.TPFTestComponent;
import org.eclipse.hyades.models.common.testprofile.TPFTestObjective;
import org.eclipse.hyades.models.common.testprofile.TPFTestSuite;
import org.eclipse.hyades.models.common.testprofile.TPFTimezone;
import org.eclipse.hyades.models.common.testprofile.TPFTypedEvent;
import org.eclipse.hyades.models.common.testprofile.TPFValidationAction;
import org.eclipse.hyades.models.common.testprofile.TPFVerdict;
import org.eclipse.hyades.models.common.testprofile.TPFVerdictEvent;
import org.eclipse.hyades.models.common.testprofile.TPFVerdictReason;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class Common_TestprofilePackageImpl extends EPackageImpl implements Common_TestprofilePackage
{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfDeploymentEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfLiteralAnyorNullEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfLiteralAnyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfInstanceValueEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfExecutionResultEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfLogActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfDefaultEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfDefaultApplicationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfBehaviorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfTestCaseEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfArbiterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfCodingRuleEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfsutEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfTestSuiteEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfTestObjectiveEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfTestComponentEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfTimezoneEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfValidationActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfExecutionHistoryEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfExecutionEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfExecutionStatusEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfInvocationEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfVerdictEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfMessageEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfTypedEventEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tpfTestEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum tpfVerdictEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum tpfExecutionTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum tpfSeverityEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum tpfInvocationStatusEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum tpfVerdictReasonEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum tpfInvocationReasonEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private Common_TestprofilePackageImpl()
	{
		super(eNS_URI, Common_TestprofileFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this
	 * model, and for any others upon which it depends.  Simple
	 * dependencies are satisfied by calling this method on all
	 * dependent packages before doing anything else.  This method drives
	 * initialization for interdependent packages directly, in parallel
	 * with this package, itself.
	 * <p>Of this package and its interdependencies, all packages which
	 * have not yet been registered by their URI values are first created
	 * and registered.  The packages are then initialized in two steps:
	 * meta-model objects for all of the packages are created before any
	 * are initialized, since one package's meta-model objects may refer to
	 * those of another.
	 * <p>Invocation of this method will not affect any packages that have
	 * already been initialized.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static Common_TestprofilePackage init()
	{
		if (isInited) return (Common_TestprofilePackage)EPackage.Registry.INSTANCE.get(Common_TestprofilePackage.eNS_URI);
		isInited = true;

		// Obtain or create and register package and interdependencies
		Common_TestprofilePackageImpl theCommon_TestprofilePackage = (Common_TestprofilePackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(eNS_URI) : new Common_TestprofilePackageImpl());
		Common_Behavior_InteractionsPackageImpl theCommon_Behavior_InteractionsPackage = (Common_Behavior_InteractionsPackageImpl)(EPackage.Registry.INSTANCE.get(Common_Behavior_InteractionsPackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(Common_Behavior_InteractionsPackage.eNS_URI) : Common_Behavior_InteractionsPackageImpl.eINSTANCE);
		Common_Behavior_FragmentsPackageImpl theCommon_Behavior_FragmentsPackage = (Common_Behavior_FragmentsPackageImpl)(EPackage.Registry.INSTANCE.get(Common_Behavior_FragmentsPackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(Common_Behavior_FragmentsPackage.eNS_URI) : Common_Behavior_FragmentsPackageImpl.eINSTANCE);
		Common_ConfigurationPackageImpl theCommon_ConfigurationPackage = (Common_ConfigurationPackageImpl)(EPackage.Registry.INSTANCE.get(Common_ConfigurationPackage.eNS_URI) instanceof EPackage ? EPackage.Registry.INSTANCE.get(Common_ConfigurationPackage.eNS_URI) : Common_ConfigurationPackageImpl.eINSTANCE);

		// Step 1: create meta-model objects
		theCommon_TestprofilePackage.createPackageContents();
		theCommon_Behavior_InteractionsPackage.createPackageContents();
		theCommon_Behavior_FragmentsPackage.createPackageContents();
		theCommon_ConfigurationPackage.createPackageContents();

		// Step 2: complete initialization
		theCommon_TestprofilePackage.initializePackageContents();
		theCommon_Behavior_InteractionsPackage.initializePackageContents();
		theCommon_Behavior_FragmentsPackage.initializePackageContents();
		theCommon_ConfigurationPackage.initializePackageContents();

		return theCommon_TestprofilePackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFDeployment()
	{
		return tpfDeploymentEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFDeployment_Name()
	{
		return (EAttribute)tpfDeploymentEClass.getEAttributes().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFDeployment_Description()
	{
		return (EAttribute)tpfDeploymentEClass.getEAttributes().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFDeployment_Locations()
	{
		return (EReference)tpfDeploymentEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFDeployment_Artifacts()
	{
		return (EReference)tpfDeploymentEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFDeployment_DeploymentSpecs()
	{
		return (EReference)tpfDeploymentEClass.getEReferences().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFLiteralAnyorNull()
	{
		return tpfLiteralAnyorNullEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFLiteralAnyorNull_Value()
	{
		return (EReference)tpfLiteralAnyorNullEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFLiteralAny()
	{
		return tpfLiteralAnyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFLiteralAny_Value()
	{
		return (EReference)tpfLiteralAnyEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFInstanceValue()
	{
		return tpfInstanceValueEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFInstanceValue_Name()
	{
		return (EAttribute)tpfInstanceValueEClass.getEAttributes().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFInstanceValue_Description()
	{
		return (EAttribute)tpfInstanceValueEClass.getEAttributes().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFInstanceValue_LiteralAny()
	{
		return (EReference)tpfInstanceValueEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFInstanceValue_LiteralAnyOrNull()
	{
		return (EReference)tpfInstanceValueEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFInstanceValue_Coding()
	{
		return (EReference)tpfInstanceValueEClass.getEReferences().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFExecutionResult()
	{
		return tpfExecutionResultEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFExecutionResult_Id()
	{
		return (EAttribute)tpfExecutionResultEClass.getEAttributes().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFExecutionResult_Verdict()
	{
		return (EAttribute)tpfExecutionResultEClass.getEAttributes().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFExecutionResult_Name()
	{
		return (EAttribute)tpfExecutionResultEClass.getEAttributes().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFExecutionResult_Description()
	{
		return (EAttribute)tpfExecutionResultEClass.getEAttributes().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFExecutionResult_TestVersion()
	{
		return (EAttribute)tpfExecutionResultEClass.getEAttributes().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFExecutionResult_Deployment()
	{
		return (EReference)tpfExecutionResultEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFExecutionResult_ExecutionHistory()
	{
		return (EReference)tpfExecutionResultEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFExecutionResult_Test()
	{
		return (EReference)tpfExecutionResultEClass.getEReferences().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFLogAction()
	{
		return tpfLogActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFDefault()
	{
		return tpfDefaultEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFDefault_DefaultApplications()
	{
		return (EReference)tpfDefaultEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFDefaultApplication()
	{
		return tpfDefaultApplicationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFDefaultApplication_TestComponent()
	{
		return (EReference)tpfDefaultApplicationEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFDefaultApplication_MessageEnd()
	{
		return (EReference)tpfDefaultApplicationEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFDefaultApplication_Lifeline()
	{
		return (EReference)tpfDefaultApplicationEClass.getEReferences().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFDefaultApplication_InteractionFragment()
	{
		return (EReference)tpfDefaultApplicationEClass.getEReferences().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFDefaultApplication_Default()
	{
		return (EReference)tpfDefaultApplicationEClass.getEReferences().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFBehavior()
	{
		return tpfBehaviorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFBehavior_IsReentrant()
	{
		return (EAttribute)tpfBehaviorEClass.getEAttributes().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFBehavior_Name()
	{
		return (EAttribute)tpfBehaviorEClass.getEAttributes().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFBehavior_Description()
	{
		return (EAttribute)tpfBehaviorEClass.getEAttributes().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFBehavior_Interaction()
	{
		return (EReference)tpfBehaviorEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFTestCase()
	{
		return tpfTestCaseEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFTestCase_Id()
	{
		return (EAttribute)tpfTestCaseEClass.getEAttributes().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFTestCase_Name()
	{
		return (EAttribute)tpfTestCaseEClass.getEAttributes().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFTestCase_Description()
	{
		return (EAttribute)tpfTestCaseEClass.getEAttributes().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFTestCase_TestSuite()
	{
		return (EReference)tpfTestCaseEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFArbiter()
	{
		return tpfArbiterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFArbiter_Behaviors()
	{
		return (EReference)tpfArbiterEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFArbiter_TestSuite()
	{
		return (EReference)tpfArbiterEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFCodingRule()
	{
		return tpfCodingRuleEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFCodingRule_Coding()
	{
		return (EAttribute)tpfCodingRuleEClass.getEAttributes().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFCodingRule_Value()
	{
		return (EReference)tpfCodingRuleEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFSUT()
	{
		return tpfsutEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFSUT_TestSuite()
	{
		return (EReference)tpfsutEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFTestSuite()
	{
		return tpfTestSuiteEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFTestSuite_TestCases()
	{
		return (EReference)tpfTestSuiteEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFTestSuite_SUTs()
	{
		return (EReference)tpfTestSuiteEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFTestSuite_Arbiter()
	{
		return (EReference)tpfTestSuiteEClass.getEReferences().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFTestSuite_TestComponents()
	{
		return (EReference)tpfTestSuiteEClass.getEReferences().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFTestObjective()
	{
		return tpfTestObjectiveEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFTestObjective_Name()
	{
		return (EAttribute)tpfTestObjectiveEClass.getEAttributes().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFTestObjective_Description()
	{
		return (EAttribute)tpfTestObjectiveEClass.getEAttributes().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFTestObjective_Type()
	{
		return (EAttribute)tpfTestObjectiveEClass.getEAttributes().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFTestObjective_Reference()
	{
		return (EAttribute)tpfTestObjectiveEClass.getEAttributes().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFTestObjective_Test()
	{
		return (EReference)tpfTestObjectiveEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFTestComponent()
	{
		return tpfTestComponentEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFTestComponent_Behaviors()
	{
		return (EReference)tpfTestComponentEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFTestComponent_TestSuite()
	{
		return (EReference)tpfTestComponentEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFTimezone()
	{
		return tpfTimezoneEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFTimezone_Name()
	{
		return (EAttribute)tpfTimezoneEClass.getEAttributes().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFTimezone_Description()
	{
		return (EAttribute)tpfTimezoneEClass.getEAttributes().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFTimezone_Locations()
	{
		return (EReference)tpfTimezoneEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFValidationAction()
	{
		return tpfValidationActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFExecutionHistory()
	{
		return tpfExecutionHistoryEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFExecutionHistory_ExecutionResult()
	{
		return (EReference)tpfExecutionHistoryEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFExecutionHistory_ExecutionEvents()
	{
		return (EReference)tpfExecutionHistoryEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFExecutionHistory_InvocationExecutionEvent()
	{
		return (EReference)tpfExecutionHistoryEClass.getEReferences().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFExecutionEvent()
	{
		return tpfExecutionEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFExecutionEvent_Id()
	{
		return (EAttribute)tpfExecutionEventEClass.getEAttributes().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFExecutionEvent_OwnerId()
	{
		return (EAttribute)tpfExecutionEventEClass.getEAttributes().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFExecutionEvent_Timestamp()
	{
		return (EAttribute)tpfExecutionEventEClass.getEAttributes().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFExecutionEvent_Text()
	{
		return (EAttribute)tpfExecutionEventEClass.getEAttributes().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFExecutionEvent_ExecutionHistory()
	{
		return (EReference)tpfExecutionEventEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFExecutionEvent_InteractionFragment()
	{
		return (EReference)tpfExecutionEventEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFExecutionStatus()
	{
		return tpfExecutionStatusEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFInvocationEvent()
	{
		return tpfInvocationEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFInvocationEvent_Status()
	{
		return (EAttribute)tpfInvocationEventEClass.getEAttributes().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFInvocationEvent_Reason()
	{
		return (EAttribute)tpfInvocationEventEClass.getEAttributes().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFInvocationEvent_InvokedExecutionHistory()
	{
		return (EReference)tpfInvocationEventEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFVerdictEvent()
	{
		return tpfVerdictEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFVerdictEvent_Verdict()
	{
		return (EAttribute)tpfVerdictEventEClass.getEAttributes().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFVerdictEvent_Reason()
	{
		return (EAttribute)tpfVerdictEventEClass.getEAttributes().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFMessageEvent()
	{
		return tpfMessageEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFMessageEvent_Severity()
	{
		return (EAttribute)tpfMessageEventEClass.getEAttributes().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFTypedEvent()
	{
		return tpfTypedEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFTypedEvent_Type()
	{
		return (EAttribute)tpfTypedEventEClass.getEAttributes().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTPFTest()
	{
		return tpfTestEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTPFTest_Type()
	{
		return (EAttribute)tpfTestEClass.getEAttributes().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFTest_TestObjectives()
	{
		return (EReference)tpfTestEClass.getEReferences().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTPFTest_Behavior()
	{
		return (EReference)tpfTestEClass.getEReferences().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getTPFVerdict()
	{
		return tpfVerdictEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getTPFExecutionType()
	{
		return tpfExecutionTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getTPFSeverity()
	{
		return tpfSeverityEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getTPFInvocationStatus()
	{
		return tpfInvocationStatusEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getTPFVerdictReason()
	{
		return tpfVerdictReasonEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getTPFInvocationReason()
	{
		return tpfInvocationReasonEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Common_TestprofileFactory getCommon_TestprofileFactory()
	{
		return (Common_TestprofileFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents()
	{
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		tpfDeploymentEClass = createEClass(TPF_DEPLOYMENT);
		createEAttribute(tpfDeploymentEClass, TPF_DEPLOYMENT__NAME);
		createEAttribute(tpfDeploymentEClass, TPF_DEPLOYMENT__DESCRIPTION);
		createEReference(tpfDeploymentEClass, TPF_DEPLOYMENT__LOCATIONS);
		createEReference(tpfDeploymentEClass, TPF_DEPLOYMENT__ARTIFACTS);
		createEReference(tpfDeploymentEClass, TPF_DEPLOYMENT__DEPLOYMENT_SPECS);

		tpfLiteralAnyorNullEClass = createEClass(TPF_LITERAL_ANYOR_NULL);
		createEReference(tpfLiteralAnyorNullEClass, TPF_LITERAL_ANYOR_NULL__VALUE);

		tpfLiteralAnyEClass = createEClass(TPF_LITERAL_ANY);
		createEReference(tpfLiteralAnyEClass, TPF_LITERAL_ANY__VALUE);

		tpfInstanceValueEClass = createEClass(TPF_INSTANCE_VALUE);
		createEAttribute(tpfInstanceValueEClass, TPF_INSTANCE_VALUE__NAME);
		createEAttribute(tpfInstanceValueEClass, TPF_INSTANCE_VALUE__DESCRIPTION);
		createEReference(tpfInstanceValueEClass, TPF_INSTANCE_VALUE__LITERAL_ANY);
		createEReference(tpfInstanceValueEClass, TPF_INSTANCE_VALUE__LITERAL_ANY_OR_NULL);
		createEReference(tpfInstanceValueEClass, TPF_INSTANCE_VALUE__CODING);

		tpfExecutionResultEClass = createEClass(TPF_EXECUTION_RESULT);
		createEAttribute(tpfExecutionResultEClass, TPF_EXECUTION_RESULT__ID);
		createEAttribute(tpfExecutionResultEClass, TPF_EXECUTION_RESULT__VERDICT);
		createEAttribute(tpfExecutionResultEClass, TPF_EXECUTION_RESULT__NAME);
		createEAttribute(tpfExecutionResultEClass, TPF_EXECUTION_RESULT__DESCRIPTION);
		createEAttribute(tpfExecutionResultEClass, TPF_EXECUTION_RESULT__TEST_VERSION);
		createEReference(tpfExecutionResultEClass, TPF_EXECUTION_RESULT__DEPLOYMENT);
		createEReference(tpfExecutionResultEClass, TPF_EXECUTION_RESULT__EXECUTION_HISTORY);
		createEReference(tpfExecutionResultEClass, TPF_EXECUTION_RESULT__TEST);

		tpfLogActionEClass = createEClass(TPF_LOG_ACTION);

		tpfDefaultEClass = createEClass(TPF_DEFAULT);
		createEReference(tpfDefaultEClass, TPF_DEFAULT__DEFAULT_APPLICATIONS);

		tpfDefaultApplicationEClass = createEClass(TPF_DEFAULT_APPLICATION);
		createEReference(tpfDefaultApplicationEClass, TPF_DEFAULT_APPLICATION__TEST_COMPONENT);
		createEReference(tpfDefaultApplicationEClass, TPF_DEFAULT_APPLICATION__MESSAGE_END);
		createEReference(tpfDefaultApplicationEClass, TPF_DEFAULT_APPLICATION__LIFELINE);
		createEReference(tpfDefaultApplicationEClass, TPF_DEFAULT_APPLICATION__INTERACTION_FRAGMENT);
		createEReference(tpfDefaultApplicationEClass, TPF_DEFAULT_APPLICATION__DEFAULT);

		tpfBehaviorEClass = createEClass(TPF_BEHAVIOR);
		createEAttribute(tpfBehaviorEClass, TPF_BEHAVIOR__IS_REENTRANT);
		createEAttribute(tpfBehaviorEClass, TPF_BEHAVIOR__NAME);
		createEAttribute(tpfBehaviorEClass, TPF_BEHAVIOR__DESCRIPTION);
		createEReference(tpfBehaviorEClass, TPF_BEHAVIOR__INTERACTION);

		tpfTestCaseEClass = createEClass(TPF_TEST_CASE);
		createEAttribute(tpfTestCaseEClass, TPF_TEST_CASE__ID);
		createEAttribute(tpfTestCaseEClass, TPF_TEST_CASE__NAME);
		createEAttribute(tpfTestCaseEClass, TPF_TEST_CASE__DESCRIPTION);
		createEReference(tpfTestCaseEClass, TPF_TEST_CASE__TEST_SUITE);

		tpfArbiterEClass = createEClass(TPF_ARBITER);
		createEReference(tpfArbiterEClass, TPF_ARBITER__BEHAVIORS);
		createEReference(tpfArbiterEClass, TPF_ARBITER__TEST_SUITE);

		tpfCodingRuleEClass = createEClass(TPF_CODING_RULE);
		createEAttribute(tpfCodingRuleEClass, TPF_CODING_RULE__CODING);
		createEReference(tpfCodingRuleEClass, TPF_CODING_RULE__VALUE);

		tpfsutEClass = createEClass(TPFSUT);
		createEReference(tpfsutEClass, TPFSUT__TEST_SUITE);

		tpfTestSuiteEClass = createEClass(TPF_TEST_SUITE);
		createEReference(tpfTestSuiteEClass, TPF_TEST_SUITE__TEST_CASES);
		createEReference(tpfTestSuiteEClass, TPF_TEST_SUITE__SU_TS);
		createEReference(tpfTestSuiteEClass, TPF_TEST_SUITE__ARBITER);
		createEReference(tpfTestSuiteEClass, TPF_TEST_SUITE__TEST_COMPONENTS);

		tpfTestObjectiveEClass = createEClass(TPF_TEST_OBJECTIVE);
		createEAttribute(tpfTestObjectiveEClass, TPF_TEST_OBJECTIVE__NAME);
		createEAttribute(tpfTestObjectiveEClass, TPF_TEST_OBJECTIVE__DESCRIPTION);
		createEAttribute(tpfTestObjectiveEClass, TPF_TEST_OBJECTIVE__TYPE);
		createEAttribute(tpfTestObjectiveEClass, TPF_TEST_OBJECTIVE__REFERENCE);
		createEReference(tpfTestObjectiveEClass, TPF_TEST_OBJECTIVE__TEST);

		tpfTestComponentEClass = createEClass(TPF_TEST_COMPONENT);
		createEReference(tpfTestComponentEClass, TPF_TEST_COMPONENT__BEHAVIORS);
		createEReference(tpfTestComponentEClass, TPF_TEST_COMPONENT__TEST_SUITE);

		tpfTimezoneEClass = createEClass(TPF_TIMEZONE);
		createEAttribute(tpfTimezoneEClass, TPF_TIMEZONE__NAME);
		createEAttribute(tpfTimezoneEClass, TPF_TIMEZONE__DESCRIPTION);
		createEReference(tpfTimezoneEClass, TPF_TIMEZONE__LOCATIONS);

		tpfValidationActionEClass = createEClass(TPF_VALIDATION_ACTION);

		tpfExecutionHistoryEClass = createEClass(TPF_EXECUTION_HISTORY);
		createEReference(tpfExecutionHistoryEClass, TPF_EXECUTION_HISTORY__EXECUTION_RESULT);
		createEReference(tpfExecutionHistoryEClass, TPF_EXECUTION_HISTORY__EXECUTION_EVENTS);
		createEReference(tpfExecutionHistoryEClass, TPF_EXECUTION_HISTORY__INVOCATION_EXECUTION_EVENT);

		tpfExecutionEventEClass = createEClass(TPF_EXECUTION_EVENT);
		createEAttribute(tpfExecutionEventEClass, TPF_EXECUTION_EVENT__ID);
		createEAttribute(tpfExecutionEventEClass, TPF_EXECUTION_EVENT__OWNER_ID);
		createEAttribute(tpfExecutionEventEClass, TPF_EXECUTION_EVENT__TIMESTAMP);
		createEAttribute(tpfExecutionEventEClass, TPF_EXECUTION_EVENT__TEXT);
		createEReference(tpfExecutionEventEClass, TPF_EXECUTION_EVENT__EXECUTION_HISTORY);
		createEReference(tpfExecutionEventEClass, TPF_EXECUTION_EVENT__INTERACTION_FRAGMENT);

		tpfExecutionStatusEClass = createEClass(TPF_EXECUTION_STATUS);

		tpfInvocationEventEClass = createEClass(TPF_INVOCATION_EVENT);
		createEAttribute(tpfInvocationEventEClass, TPF_INVOCATION_EVENT__STATUS);
		createEAttribute(tpfInvocationEventEClass, TPF_INVOCATION_EVENT__REASON);
		createEReference(tpfInvocationEventEClass, TPF_INVOCATION_EVENT__INVOKED_EXECUTION_HISTORY);

		tpfVerdictEventEClass = createEClass(TPF_VERDICT_EVENT);
		createEAttribute(tpfVerdictEventEClass, TPF_VERDICT_EVENT__VERDICT);
		createEAttribute(tpfVerdictEventEClass, TPF_VERDICT_EVENT__REASON);

		tpfMessageEventEClass = createEClass(TPF_MESSAGE_EVENT);
		createEAttribute(tpfMessageEventEClass, TPF_MESSAGE_EVENT__SEVERITY);

		tpfTypedEventEClass = createEClass(TPF_TYPED_EVENT);
		createEAttribute(tpfTypedEventEClass, TPF_TYPED_EVENT__TYPE);

		tpfTestEClass = createEClass(TPF_TEST);
		createEAttribute(tpfTestEClass, TPF_TEST__TYPE);
		createEReference(tpfTestEClass, TPF_TEST__TEST_OBJECTIVES);
		createEReference(tpfTestEClass, TPF_TEST__BEHAVIOR);

		// Create enums
		tpfVerdictEEnum = createEEnum(TPF_VERDICT);
		tpfExecutionTypeEEnum = createEEnum(TPF_EXECUTION_TYPE);
		tpfSeverityEEnum = createEEnum(TPF_SEVERITY);
		tpfInvocationStatusEEnum = createEEnum(TPF_INVOCATION_STATUS);
		tpfVerdictReasonEEnum = createEEnum(TPF_VERDICT_REASON);
		tpfInvocationReasonEEnum = createEEnum(TPF_INVOCATION_REASON);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents()
	{
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		Common_ConfigurationPackageImpl theCommon_ConfigurationPackage = (Common_ConfigurationPackageImpl)EPackage.Registry.INSTANCE.getEPackage(Common_ConfigurationPackage.eNS_URI);
		Common_Behavior_InteractionsPackageImpl theCommon_Behavior_InteractionsPackage = (Common_Behavior_InteractionsPackageImpl)EPackage.Registry.INSTANCE.getEPackage(Common_Behavior_InteractionsPackage.eNS_URI);
		Common_Behavior_FragmentsPackageImpl theCommon_Behavior_FragmentsPackage = (Common_Behavior_FragmentsPackageImpl)EPackage.Registry.INSTANCE.getEPackage(Common_Behavior_FragmentsPackage.eNS_URI);

		// Add supertypes to classes
		tpfLogActionEClass.getESuperTypes().add(theCommon_Behavior_InteractionsPackage.getBVREventOccurrence());
		tpfDefaultEClass.getESuperTypes().add(this.getTPFBehavior());
		tpfTestCaseEClass.getESuperTypes().add(this.getTPFTest());
		tpfArbiterEClass.getESuperTypes().add(theCommon_ConfigurationPackage.getCFGDeployable());
		tpfsutEClass.getESuperTypes().add(theCommon_ConfigurationPackage.getCFGDeployable());
		tpfTestSuiteEClass.getESuperTypes().add(theCommon_ConfigurationPackage.getCFGDeployable());
		tpfTestSuiteEClass.getESuperTypes().add(this.getTPFTest());
		tpfTestComponentEClass.getESuperTypes().add(theCommon_ConfigurationPackage.getCFGDeployable());
		tpfValidationActionEClass.getESuperTypes().add(theCommon_Behavior_InteractionsPackage.getBVREventOccurrence());
		tpfInvocationEventEClass.getESuperTypes().add(this.getTPFExecutionEvent());
		tpfVerdictEventEClass.getESuperTypes().add(this.getTPFExecutionEvent());
		tpfMessageEventEClass.getESuperTypes().add(this.getTPFExecutionEvent());
		tpfTypedEventEClass.getESuperTypes().add(this.getTPFExecutionEvent());

		// Initialize classes and features; add operations and parameters
		initEClass(tpfDeploymentEClass, TPFDeployment.class, "TPFDeployment", !IS_ABSTRACT, !IS_INTERFACE);
		initEAttribute(getTPFDeployment_Name(), ecorePackage.getEString(), "name", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFDeployment_Description(), ecorePackage.getEString(), "description", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEReference(getTPFDeployment_Locations(), theCommon_ConfigurationPackage.getCFGLocation(), theCommon_ConfigurationPackage.getCFGLocation_Deployment(), "locations", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFDeployment_Artifacts(), theCommon_ConfigurationPackage.getCFGArtifact(), theCommon_ConfigurationPackage.getCFGArtifact_Deployment(), "artifacts", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFDeployment_DeploymentSpecs(), theCommon_ConfigurationPackage.getCFGDeploymentSpec(), theCommon_ConfigurationPackage.getCFGDeploymentSpec_Deployment(), "deploymentSpecs", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfLiteralAnyorNullEClass, TPFLiteralAnyorNull.class, "TPFLiteralAnyorNull", !IS_ABSTRACT, !IS_INTERFACE);
		initEReference(getTPFLiteralAnyorNull_Value(), this.getTPFInstanceValue(), this.getTPFInstanceValue_LiteralAnyOrNull(), "value", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfLiteralAnyEClass, TPFLiteralAny.class, "TPFLiteralAny", !IS_ABSTRACT, !IS_INTERFACE);
		initEReference(getTPFLiteralAny_Value(), this.getTPFInstanceValue(), this.getTPFInstanceValue_LiteralAny(), "value", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfInstanceValueEClass, TPFInstanceValue.class, "TPFInstanceValue", !IS_ABSTRACT, !IS_INTERFACE);
		initEAttribute(getTPFInstanceValue_Name(), ecorePackage.getEString(), "name", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFInstanceValue_Description(), ecorePackage.getEString(), "description", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEReference(getTPFInstanceValue_LiteralAny(), this.getTPFLiteralAny(), this.getTPFLiteralAny_Value(), "literalAny", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFInstanceValue_LiteralAnyOrNull(), this.getTPFLiteralAnyorNull(), this.getTPFLiteralAnyorNull_Value(), "literalAnyOrNull", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFInstanceValue_Coding(), this.getTPFCodingRule(), this.getTPFCodingRule_Value(), "coding", null, 1, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfExecutionResultEClass, TPFExecutionResult.class, "TPFExecutionResult", !IS_ABSTRACT, !IS_INTERFACE);
		initEAttribute(getTPFExecutionResult_Id(), ecorePackage.getEString(), "id", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFExecutionResult_Verdict(), this.getTPFVerdict(), "verdict", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFExecutionResult_Name(), ecorePackage.getEString(), "name", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFExecutionResult_Description(), ecorePackage.getEString(), "description", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFExecutionResult_TestVersion(), ecorePackage.getEString(), "testVersion", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEReference(getTPFExecutionResult_Deployment(), this.getTPFDeployment(), null, "deployment", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFExecutionResult_ExecutionHistory(), this.getTPFExecutionHistory(), this.getTPFExecutionHistory_ExecutionResult(), "executionHistory", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFExecutionResult_Test(), this.getTPFTest(), null, "test", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfLogActionEClass, TPFLogAction.class, "TPFLogAction", !IS_ABSTRACT, !IS_INTERFACE);

		initEClass(tpfDefaultEClass, TPFDefault.class, "TPFDefault", !IS_ABSTRACT, !IS_INTERFACE);
		initEReference(getTPFDefault_DefaultApplications(), this.getTPFDefaultApplication(), this.getTPFDefaultApplication_Default(), "defaultApplications", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfDefaultApplicationEClass, TPFDefaultApplication.class, "TPFDefaultApplication", !IS_ABSTRACT, !IS_INTERFACE);
		initEReference(getTPFDefaultApplication_TestComponent(), this.getTPFTestComponent(), null, "testComponent", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFDefaultApplication_MessageEnd(), theCommon_Behavior_InteractionsPackage.getBVRMessageEnd(), null, "messageEnd", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFDefaultApplication_Lifeline(), theCommon_Behavior_InteractionsPackage.getBVRLifeline(), null, "lifeline", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFDefaultApplication_InteractionFragment(), theCommon_Behavior_InteractionsPackage.getBVRInteractionFragment(), theCommon_Behavior_InteractionsPackage.getBVRInteractionFragment_DefaultApplication(), "interactionFragment", null, 0, 1, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFDefaultApplication_Default(), this.getTPFDefault(), this.getTPFDefault_DefaultApplications(), "default", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfBehaviorEClass, TPFBehavior.class, "TPFBehavior", !IS_ABSTRACT, !IS_INTERFACE);
		initEAttribute(getTPFBehavior_IsReentrant(), ecorePackage.getEBooleanObject(), "isReentrant", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFBehavior_Name(), ecorePackage.getEString(), "name", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFBehavior_Description(), ecorePackage.getEString(), "description", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEReference(getTPFBehavior_Interaction(), theCommon_Behavior_FragmentsPackage.getBVRInteraction(), theCommon_Behavior_FragmentsPackage.getBVRInteraction_Behavior(), "interaction", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfTestCaseEClass, TPFTestCase.class, "TPFTestCase", !IS_ABSTRACT, !IS_INTERFACE);
		initEAttribute(getTPFTestCase_Id(), ecorePackage.getEString(), "id", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFTestCase_Name(), ecorePackage.getEString(), "name", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFTestCase_Description(), ecorePackage.getEString(), "description", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEReference(getTPFTestCase_TestSuite(), this.getTPFTestSuite(), this.getTPFTestSuite_TestCases(), "testSuite", null, 1, 1, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfArbiterEClass, TPFArbiter.class, "TPFArbiter", !IS_ABSTRACT, !IS_INTERFACE);
		initEReference(getTPFArbiter_Behaviors(), this.getTPFBehavior(), null, "behaviors", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFArbiter_TestSuite(), this.getTPFTestSuite(), this.getTPFTestSuite_Arbiter(), "testSuite", null, 0, 1, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfCodingRuleEClass, TPFCodingRule.class, "TPFCodingRule", !IS_ABSTRACT, !IS_INTERFACE);
		initEAttribute(getTPFCodingRule_Coding(), ecorePackage.getEString(), "coding", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEReference(getTPFCodingRule_Value(), this.getTPFInstanceValue(), this.getTPFInstanceValue_Coding(), "value", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfsutEClass, TPFSUT.class, "TPFSUT", !IS_ABSTRACT, !IS_INTERFACE);
		initEReference(getTPFSUT_TestSuite(), this.getTPFTestSuite(), this.getTPFTestSuite_SUTs(), "testSuite", null, 0, 1, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfTestSuiteEClass, TPFTestSuite.class, "TPFTestSuite", !IS_ABSTRACT, !IS_INTERFACE);
		initEReference(getTPFTestSuite_TestCases(), this.getTPFTestCase(), this.getTPFTestCase_TestSuite(), "testCases", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFTestSuite_SUTs(), this.getTPFSUT(), this.getTPFSUT_TestSuite(), "SUTs", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFTestSuite_Arbiter(), this.getTPFArbiter(), this.getTPFArbiter_TestSuite(), "arbiter", null, 1, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFTestSuite_TestComponents(), this.getTPFTestComponent(), this.getTPFTestComponent_TestSuite(), "testComponents", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfTestObjectiveEClass, TPFTestObjective.class, "TPFTestObjective", !IS_ABSTRACT, !IS_INTERFACE);
		initEAttribute(getTPFTestObjective_Name(), ecorePackage.getEString(), "name", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFTestObjective_Description(), ecorePackage.getEString(), "description", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFTestObjective_Type(), ecorePackage.getEString(), "type", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFTestObjective_Reference(), ecorePackage.getEString(), "reference", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEReference(getTPFTestObjective_Test(), this.getTPFTest(), this.getTPFTest_TestObjectives(), "test", null, 1, 1, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfTestComponentEClass, TPFTestComponent.class, "TPFTestComponent", !IS_ABSTRACT, !IS_INTERFACE);
		initEReference(getTPFTestComponent_Behaviors(), this.getTPFBehavior(), null, "behaviors", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFTestComponent_TestSuite(), this.getTPFTestSuite(), this.getTPFTestSuite_TestComponents(), "testSuite", null, 0, 1, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfTimezoneEClass, TPFTimezone.class, "TPFTimezone", !IS_ABSTRACT, !IS_INTERFACE);
		initEAttribute(getTPFTimezone_Name(), ecorePackage.getEString(), "name", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFTimezone_Description(), ecorePackage.getEString(), "description", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEReference(getTPFTimezone_Locations(), theCommon_ConfigurationPackage.getCFGLocation(), theCommon_ConfigurationPackage.getCFGLocation_Timezone(), "locations", null, 0, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfValidationActionEClass, TPFValidationAction.class, "TPFValidationAction", !IS_ABSTRACT, !IS_INTERFACE);

		initEClass(tpfExecutionHistoryEClass, TPFExecutionHistory.class, "TPFExecutionHistory", !IS_ABSTRACT, !IS_INTERFACE);
		initEReference(getTPFExecutionHistory_ExecutionResult(), this.getTPFExecutionResult(), this.getTPFExecutionResult_ExecutionHistory(), "executionResult", null, 1, 1, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFExecutionHistory_ExecutionEvents(), this.getTPFExecutionEvent(), this.getTPFExecutionEvent_ExecutionHistory(), "executionEvents", null, 1, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFExecutionHistory_InvocationExecutionEvent(), this.getTPFInvocationEvent(), this.getTPFInvocationEvent_InvokedExecutionHistory(), "invocationExecutionEvent", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfExecutionEventEClass, TPFExecutionEvent.class, "TPFExecutionEvent", !IS_ABSTRACT, !IS_INTERFACE);
		initEAttribute(getTPFExecutionEvent_Id(), ecorePackage.getEString(), "id", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFExecutionEvent_OwnerId(), ecorePackage.getEString(), "ownerId", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFExecutionEvent_Timestamp(), ecorePackage.getELong(), "timestamp", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFExecutionEvent_Text(), ecorePackage.getEString(), "text", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEReference(getTPFExecutionEvent_ExecutionHistory(), this.getTPFExecutionHistory(), this.getTPFExecutionHistory_ExecutionEvents(), "executionHistory", null, 1, 1, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFExecutionEvent_InteractionFragment(), theCommon_Behavior_InteractionsPackage.getBVRInteractionFragment(), null, "interactionFragment", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfExecutionStatusEClass, TPFExecutionStatus.class, "TPFExecutionStatus", !IS_ABSTRACT, !IS_INTERFACE);

		initEClass(tpfInvocationEventEClass, TPFInvocationEvent.class, "TPFInvocationEvent", !IS_ABSTRACT, !IS_INTERFACE);
		initEAttribute(getTPFInvocationEvent_Status(), this.getTPFInvocationStatus(), "status", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFInvocationEvent_Reason(), this.getTPFInvocationReason(), "reason", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEReference(getTPFInvocationEvent_InvokedExecutionHistory(), this.getTPFExecutionHistory(), this.getTPFExecutionHistory_InvocationExecutionEvent(), "invokedExecutionHistory", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		initEClass(tpfVerdictEventEClass, TPFVerdictEvent.class, "TPFVerdictEvent", !IS_ABSTRACT, !IS_INTERFACE);
		initEAttribute(getTPFVerdictEvent_Verdict(), this.getTPFVerdict(), "verdict", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEAttribute(getTPFVerdictEvent_Reason(), this.getTPFVerdictReason(), "reason", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);

		initEClass(tpfMessageEventEClass, TPFMessageEvent.class, "TPFMessageEvent", !IS_ABSTRACT, !IS_INTERFACE);
		initEAttribute(getTPFMessageEvent_Severity(), this.getTPFSeverity(), "severity", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);

		initEClass(tpfTypedEventEClass, TPFTypedEvent.class, "TPFTypedEvent", !IS_ABSTRACT, !IS_INTERFACE);
		initEAttribute(getTPFTypedEvent_Type(), this.getTPFExecutionType(), "type", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);

		initEClass(tpfTestEClass, TPFTest.class, "TPFTest", IS_ABSTRACT, !IS_INTERFACE);
		initEAttribute(getTPFTest_Type(), ecorePackage.getEString(), "type", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID);
		initEReference(getTPFTest_TestObjectives(), this.getTPFTestObjective(), this.getTPFTestObjective_Test(), "testObjectives", null, 1, -1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);
		initEReference(getTPFTest_Behavior(), this.getTPFBehavior(), null, "behavior", null, 0, 1, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE);

		// Initialize enums and add enum literals
		initEEnum(tpfVerdictEEnum, TPFVerdict.class, "TPFVerdict");
		addEEnumLiteral(tpfVerdictEEnum, TPFVerdict.PASS_LITERAL);
		addEEnumLiteral(tpfVerdictEEnum, TPFVerdict.FAIL_LITERAL);
		addEEnumLiteral(tpfVerdictEEnum, TPFVerdict.INCONCLUSIVE_LITERAL);
		addEEnumLiteral(tpfVerdictEEnum, TPFVerdict.ERROR_LITERAL);

		initEEnum(tpfExecutionTypeEEnum, TPFExecutionType.class, "TPFExecutionType");
		addEEnumLiteral(tpfExecutionTypeEEnum, TPFExecutionType.START_LITERAL);
		addEEnumLiteral(tpfExecutionTypeEEnum, TPFExecutionType.STOP_LITERAL);

		initEEnum(tpfSeverityEEnum, TPFSeverity.class, "TPFSeverity");
		addEEnumLiteral(tpfSeverityEEnum, TPFSeverity.INFO_LITERAL);
		addEEnumLiteral(tpfSeverityEEnum, TPFSeverity.ERROR_LITERAL);
		addEEnumLiteral(tpfSeverityEEnum, TPFSeverity.WARNING_LITERAL);

		initEEnum(tpfInvocationStatusEEnum, TPFInvocationStatus.class, "TPFInvocationStatus");
		addEEnumLiteral(tpfInvocationStatusEEnum, TPFInvocationStatus.SUCCESSFUL_LITERAL);
		addEEnumLiteral(tpfInvocationStatusEEnum, TPFInvocationStatus.UNSUCCESSFUL_LITERAL);
		addEEnumLiteral(tpfInvocationStatusEEnum, TPFInvocationStatus.UNATTEMPTED_LITERAL);

		initEEnum(tpfVerdictReasonEEnum, TPFVerdictReason.class, "TPFVerdictReason");
		addEEnumLiteral(tpfVerdictReasonEEnum, TPFVerdictReason.NONE_LITERAL);
		addEEnumLiteral(tpfVerdictReasonEEnum, TPFVerdictReason.SEE_DESCRIPTION_LITERAL);
		addEEnumLiteral(tpfVerdictReasonEEnum, TPFVerdictReason.UNKNOWN_LITERAL);
		addEEnumLiteral(tpfVerdictReasonEEnum, TPFVerdictReason.ABORT_LITERAL);
		addEEnumLiteral(tpfVerdictReasonEEnum, TPFVerdictReason.DID_NOT_COMPLETE_LITERAL);

		initEEnum(tpfInvocationReasonEEnum, TPFInvocationReason.class, "TPFInvocationReason");
		addEEnumLiteral(tpfInvocationReasonEEnum, TPFInvocationReason.NONE_LITERAL);
		addEEnumLiteral(tpfInvocationReasonEEnum, TPFInvocationReason.SEE_DESCRIPTION_LITERAL);
		addEEnumLiteral(tpfInvocationReasonEEnum, TPFInvocationReason.UNKNOWN_LITERAL);
		addEEnumLiteral(tpfInvocationReasonEEnum, TPFInvocationReason.PRECONDITION_NOT_MET_LITERAL);
		addEEnumLiteral(tpfInvocationReasonEEnum, TPFInvocationReason.NO_MATCHING_CONFIGURATION_LITERAL);
		addEEnumLiteral(tpfInvocationReasonEEnum, TPFInvocationReason.NO_BEHAVIOR_LITERAL);
		addEEnumLiteral(tpfInvocationReasonEEnum, TPFInvocationReason.DID_NOT_START_LITERAL);

		// Create resource
		createResource(eNS_URI);
	}
} //Common_TestprofilePackageImpl
