/**
 * <copyright>
 * </copyright>
 *
 * %W%
 * @version %I% %H%
 */
package org.eclipse.hyades.models.common.testprofile.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.hyades.models.common.configuration.impl.CFGDeployableImpl;

import org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage;
import org.eclipse.hyades.models.common.testprofile.TPFArbiter;
import org.eclipse.hyades.models.common.testprofile.TPFBehavior;
import org.eclipse.hyades.models.common.testprofile.TPFSUT;
import org.eclipse.hyades.models.common.testprofile.TPFTest;
import org.eclipse.hyades.models.common.testprofile.TPFTestCase;
import org.eclipse.hyades.models.common.testprofile.TPFTestComponent;
import org.eclipse.hyades.models.common.testprofile.TPFTestObjective;
import org.eclipse.hyades.models.common.testprofile.TPFTestSuite;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>TPF Test Suite</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.impl.TPFTestSuiteImpl#getType <em>Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.impl.TPFTestSuiteImpl#getTestObjectives <em>Test Objectives</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.impl.TPFTestSuiteImpl#getBehavior <em>Behavior</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.impl.TPFTestSuiteImpl#getTestCases <em>Test Cases</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.impl.TPFTestSuiteImpl#getSUTs <em>SU Ts</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.impl.TPFTestSuiteImpl#getArbiter <em>Arbiter</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.impl.TPFTestSuiteImpl#getTestComponents <em>Test Components</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TPFTestSuiteImpl extends CFGDeployableImpl implements TPFTestSuite
{
	/**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected static final String TYPE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected String type = TYPE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getTestObjectives() <em>Test Objectives</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTestObjectives()
	 * @generated
	 * @ordered
	 */
	protected EList testObjectives = null;

	/**
	 * The cached value of the '{@link #getBehavior() <em>Behavior</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBehavior()
	 * @generated
	 * @ordered
	 */
	protected TPFBehavior behavior = null;

	/**
	 * The cached value of the '{@link #getTestCases() <em>Test Cases</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTestCases()
	 * @generated
	 * @ordered
	 */
	protected EList testCases = null;

	/**
	 * The cached value of the '{@link #getSUTs() <em>SU Ts</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSUTs()
	 * @generated
	 * @ordered
	 */
	protected EList suTs = null;

	/**
	 * The cached value of the '{@link #getArbiter() <em>Arbiter</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getArbiter()
	 * @generated
	 * @ordered
	 */
	protected TPFArbiter arbiter = null;

	/**
	 * The cached value of the '{@link #getTestComponents() <em>Test Components</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTestComponents()
	 * @generated
	 * @ordered
	 */
	protected EList testComponents = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TPFTestSuiteImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass()
	{
		return Common_TestprofilePackage.eINSTANCE.getTPFTestSuite();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getType()
	{
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(String newType)
	{
		String oldType = type;
		type = newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_TestprofilePackage.TPF_TEST_SUITE__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getTestObjectives()
	{
		if (testObjectives == null)
		{
			testObjectives = new EObjectContainmentWithInverseEList(TPFTestObjective.class, this, Common_TestprofilePackage.TPF_TEST_SUITE__TEST_OBJECTIVES, Common_TestprofilePackage.TPF_TEST_OBJECTIVE__TEST);
		}
		return testObjectives;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TPFBehavior getBehavior()
	{
		return behavior;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetBehavior(TPFBehavior newBehavior, NotificationChain msgs)
	{
		TPFBehavior oldBehavior = behavior;
		behavior = newBehavior;
		if (eNotificationRequired())
		{
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR, oldBehavior, newBehavior);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBehavior(TPFBehavior newBehavior)
	{
		if (newBehavior != behavior)
		{
			NotificationChain msgs = null;
			if (behavior != null)
				msgs = ((InternalEObject)behavior).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR, null, msgs);
			if (newBehavior != null)
				msgs = ((InternalEObject)newBehavior).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR, null, msgs);
			msgs = basicSetBehavior(newBehavior, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR, newBehavior, newBehavior));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getTestCases()
	{
		if (testCases == null)
		{
			testCases = new EObjectContainmentWithInverseEList(TPFTestCase.class, this, Common_TestprofilePackage.TPF_TEST_SUITE__TEST_CASES, Common_TestprofilePackage.TPF_TEST_CASE__TEST_SUITE);
		}
		return testCases;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getSUTs()
	{
		if (suTs == null)
		{
			suTs = new EObjectContainmentWithInverseEList(TPFSUT.class, this, Common_TestprofilePackage.TPF_TEST_SUITE__SU_TS, Common_TestprofilePackage.TPFSUT__TEST_SUITE);
		}
		return suTs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TPFArbiter getArbiter()
	{
		return arbiter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetArbiter(TPFArbiter newArbiter, NotificationChain msgs)
	{
		TPFArbiter oldArbiter = arbiter;
		arbiter = newArbiter;
		if (eNotificationRequired())
		{
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_TestprofilePackage.TPF_TEST_SUITE__ARBITER, oldArbiter, newArbiter);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setArbiter(TPFArbiter newArbiter)
	{
		if (newArbiter != arbiter)
		{
			NotificationChain msgs = null;
			if (arbiter != null)
				msgs = ((InternalEObject)arbiter).eInverseRemove(this, Common_TestprofilePackage.TPF_ARBITER__TEST_SUITE, TPFArbiter.class, msgs);
			if (newArbiter != null)
				msgs = ((InternalEObject)newArbiter).eInverseAdd(this, Common_TestprofilePackage.TPF_ARBITER__TEST_SUITE, TPFArbiter.class, msgs);
			msgs = basicSetArbiter(newArbiter, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_TestprofilePackage.TPF_TEST_SUITE__ARBITER, newArbiter, newArbiter));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getTestComponents()
	{
		if (testComponents == null)
		{
			testComponents = new EObjectContainmentWithInverseEList(TPFTestComponent.class, this, Common_TestprofilePackage.TPF_TEST_SUITE__TEST_COMPONENTS, Common_TestprofilePackage.TPF_TEST_COMPONENT__TEST_SUITE);
		}
		return testComponents;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs)
	{
		if (featureID >= 0)
		{
			switch (eDerivedStructuralFeatureID(featureID, baseClass))
			{
				case Common_TestprofilePackage.TPF_TEST_SUITE__OPERATIONS:
					return ((InternalEList)getOperations()).basicAdd(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__LIFELINES:
					return ((InternalEList)getLifelines()).basicAdd(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__ARTIFACTS:
					return ((InternalEList)getArtifacts()).basicAdd(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__INSTANCES:
					return ((InternalEList)getInstances()).basicAdd(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_OBJECTIVES:
					return ((InternalEList)getTestObjectives()).basicAdd(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_CASES:
					return ((InternalEList)getTestCases()).basicAdd(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__SU_TS:
					return ((InternalEList)getSUTs()).basicAdd(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__ARBITER:
					if (arbiter != null)
						msgs = ((InternalEObject)arbiter).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Common_TestprofilePackage.TPF_TEST_SUITE__ARBITER, null, msgs);
					return basicSetArbiter((TPFArbiter)otherEnd, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_COMPONENTS:
					return ((InternalEList)getTestComponents()).basicAdd(otherEnd, msgs);
				default:
					return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs)
	{
		if (featureID >= 0)
		{
			switch (eDerivedStructuralFeatureID(featureID, baseClass))
			{
				case Common_TestprofilePackage.TPF_TEST_SUITE__OPERATIONS:
					return ((InternalEList)getOperations()).basicRemove(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__LIFELINES:
					return ((InternalEList)getLifelines()).basicRemove(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__ARTIFACTS:
					return ((InternalEList)getArtifacts()).basicRemove(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__INSTANCES:
					return ((InternalEList)getInstances()).basicRemove(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_OBJECTIVES:
					return ((InternalEList)getTestObjectives()).basicRemove(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR:
					return basicSetBehavior(null, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_CASES:
					return ((InternalEList)getTestCases()).basicRemove(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__SU_TS:
					return ((InternalEList)getSUTs()).basicRemove(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__ARBITER:
					return basicSetArbiter(null, msgs);
				case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_COMPONENTS:
					return ((InternalEList)getTestComponents()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_TestprofilePackage.TPF_TEST_SUITE__ID:
				return getId();
			case Common_TestprofilePackage.TPF_TEST_SUITE__NAME:
				return getName();
			case Common_TestprofilePackage.TPF_TEST_SUITE__DESCRIPTION:
				return getDescription();
			case Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR_RESOURCE:
				return getBehaviorResource();
			case Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR_LOCATION:
				return getBehaviorLocation();
			case Common_TestprofilePackage.TPF_TEST_SUITE__OPERATIONS:
				return getOperations();
			case Common_TestprofilePackage.TPF_TEST_SUITE__LIFELINES:
				return getLifelines();
			case Common_TestprofilePackage.TPF_TEST_SUITE__ARTIFACTS:
				return getArtifacts();
			case Common_TestprofilePackage.TPF_TEST_SUITE__INSTANCES:
				return getInstances();
			case Common_TestprofilePackage.TPF_TEST_SUITE__TYPE:
				return getType();
			case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_OBJECTIVES:
				return getTestObjectives();
			case Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR:
				return getBehavior();
			case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_CASES:
				return getTestCases();
			case Common_TestprofilePackage.TPF_TEST_SUITE__SU_TS:
				return getSUTs();
			case Common_TestprofilePackage.TPF_TEST_SUITE__ARBITER:
				return getArbiter();
			case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_COMPONENTS:
				return getTestComponents();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_TestprofilePackage.TPF_TEST_SUITE__ID:
				setId((String)newValue);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__NAME:
				setName((String)newValue);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR_RESOURCE:
				setBehaviorResource((String)newValue);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR_LOCATION:
				setBehaviorLocation((String)newValue);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__OPERATIONS:
				getOperations().clear();
				getOperations().addAll((Collection)newValue);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__LIFELINES:
				getLifelines().clear();
				getLifelines().addAll((Collection)newValue);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__ARTIFACTS:
				getArtifacts().clear();
				getArtifacts().addAll((Collection)newValue);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__INSTANCES:
				getInstances().clear();
				getInstances().addAll((Collection)newValue);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__TYPE:
				setType((String)newValue);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_OBJECTIVES:
				getTestObjectives().clear();
				getTestObjectives().addAll((Collection)newValue);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR:
				setBehavior((TPFBehavior)newValue);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_CASES:
				getTestCases().clear();
				getTestCases().addAll((Collection)newValue);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__SU_TS:
				getSUTs().clear();
				getSUTs().addAll((Collection)newValue);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__ARBITER:
				setArbiter((TPFArbiter)newValue);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_COMPONENTS:
				getTestComponents().clear();
				getTestComponents().addAll((Collection)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_TestprofilePackage.TPF_TEST_SUITE__ID:
				setId(ID_EDEFAULT);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR_RESOURCE:
				setBehaviorResource(BEHAVIOR_RESOURCE_EDEFAULT);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR_LOCATION:
				setBehaviorLocation(BEHAVIOR_LOCATION_EDEFAULT);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__OPERATIONS:
				getOperations().clear();
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__LIFELINES:
				getLifelines().clear();
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__ARTIFACTS:
				getArtifacts().clear();
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__INSTANCES:
				getInstances().clear();
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__TYPE:
				setType(TYPE_EDEFAULT);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_OBJECTIVES:
				getTestObjectives().clear();
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR:
				setBehavior((TPFBehavior)null);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_CASES:
				getTestCases().clear();
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__SU_TS:
				getSUTs().clear();
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__ARBITER:
				setArbiter((TPFArbiter)null);
				return;
			case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_COMPONENTS:
				getTestComponents().clear();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature)
	{
		switch (eDerivedStructuralFeatureID(eFeature))
		{
			case Common_TestprofilePackage.TPF_TEST_SUITE__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case Common_TestprofilePackage.TPF_TEST_SUITE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case Common_TestprofilePackage.TPF_TEST_SUITE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR_RESOURCE:
				return BEHAVIOR_RESOURCE_EDEFAULT == null ? behaviorResource != null : !BEHAVIOR_RESOURCE_EDEFAULT.equals(behaviorResource);
			case Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR_LOCATION:
				return BEHAVIOR_LOCATION_EDEFAULT == null ? behaviorLocation != null : !BEHAVIOR_LOCATION_EDEFAULT.equals(behaviorLocation);
			case Common_TestprofilePackage.TPF_TEST_SUITE__OPERATIONS:
				return operations != null && !operations.isEmpty();
			case Common_TestprofilePackage.TPF_TEST_SUITE__LIFELINES:
				return lifelines != null && !lifelines.isEmpty();
			case Common_TestprofilePackage.TPF_TEST_SUITE__ARTIFACTS:
				return artifacts != null && !artifacts.isEmpty();
			case Common_TestprofilePackage.TPF_TEST_SUITE__INSTANCES:
				return instances != null && !instances.isEmpty();
			case Common_TestprofilePackage.TPF_TEST_SUITE__TYPE:
				return TYPE_EDEFAULT == null ? type != null : !TYPE_EDEFAULT.equals(type);
			case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_OBJECTIVES:
				return testObjectives != null && !testObjectives.isEmpty();
			case Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR:
				return behavior != null;
			case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_CASES:
				return testCases != null && !testCases.isEmpty();
			case Common_TestprofilePackage.TPF_TEST_SUITE__SU_TS:
				return suTs != null && !suTs.isEmpty();
			case Common_TestprofilePackage.TPF_TEST_SUITE__ARBITER:
				return arbiter != null;
			case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_COMPONENTS:
				return testComponents != null && !testComponents.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class baseClass)
	{
		if (baseClass == TPFTest.class)
		{
			switch (derivedFeatureID)
			{
				case Common_TestprofilePackage.TPF_TEST_SUITE__TYPE: return Common_TestprofilePackage.TPF_TEST__TYPE;
				case Common_TestprofilePackage.TPF_TEST_SUITE__TEST_OBJECTIVES: return Common_TestprofilePackage.TPF_TEST__TEST_OBJECTIVES;
				case Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR: return Common_TestprofilePackage.TPF_TEST__BEHAVIOR;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class baseClass)
	{
		if (baseClass == TPFTest.class)
		{
			switch (baseFeatureID)
			{
				case Common_TestprofilePackage.TPF_TEST__TYPE: return Common_TestprofilePackage.TPF_TEST_SUITE__TYPE;
				case Common_TestprofilePackage.TPF_TEST__TEST_OBJECTIVES: return Common_TestprofilePackage.TPF_TEST_SUITE__TEST_OBJECTIVES;
				case Common_TestprofilePackage.TPF_TEST__BEHAVIOR: return Common_TestprofilePackage.TPF_TEST_SUITE__BEHAVIOR;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString()
	{
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (type: ");
		result.append(type);
		result.append(')');
		return result.toString();
	}

} //TPFTestSuiteImpl
